;This program calculates sum of 2 numbers (0-9)
;Demonstrates follow skills:
;- print string to screen as prompt message
;- read character from keyboard
;- convert character input to number/vice versa
;- simple integer addition
;- character output to screen

.model medium
.stack 200h

.code
start:
        ;***** print title *****
        ;-setup DS register
        mov ax,@data            ;point DS to data segment
        mov ds,ax
        ;-print prompt message 3
        mov dx,offset prompt3   ;point to prompt message 3
        mov ah,09h              ;function: print string
        int 21h
        ;***** end of print title *****

        ;***** reading inputs to NUM1 and NUM2 *****
        ;-print prompt message 1
        mov dx,offset prompt1   ;point to prompt message 1
        mov ah,09h              ;function: print string
        int 21h
        ;-save first number read
        mov ah,01h              ;function: read character with echo
        int 21h
        sub al,30h              ;adjust ASCII to number
        mov NUM1,al             ;save character read into memory NUM1
		
        ;-print prompt message 2
        mov dx,offset prompt2   ;point to prompt message 2
        mov ah,09h              ;function: print string
        int 21h
        ;-save second number read
        mov ah,01h              ;function: read character with echo
        int 21h
        sub al,30h              ;adjust ASCII to number
        mov NUM2,al            ;save color number into memory NUM2
        ;***** end of inputs *****
		
        ;***** calculate sum *****
        xor al,al               ;clear AL
        add al,NUM1             ;AL=NUM1
        add al,NUM2             ;AL=NUM1+NUM2
        add al,30h              ;adjust number to ASCII
        mov SUM,al              ;save result (ASCII)
        ;***** end calculation *****

        ;***** display result *****
        mov dx,offset prompt4   ;point to prompt message 4
        mov ah,09h              ;function: print string
        int 21h

        mov ah,02h              ;function: display out
        mov dl,SUM              ;result to display
        int 21h
        mov dl,0dh              ;carriage return
        int 21h
        mov dl,0ah              ;new line
        int 21h
        ;***** end display result *****

        mov ax,4c00h            ;function: exit to DOS
        int 21h

.data
NUM1 db 0
NUM2 db 0
SUM db 0
prompt1 db 0dh,0ah,"Enter first number (0-9): $"
prompt2 db 0dh,0ah,"Enter second number (0-9): $"
prompt3 db "Simple Calculator Program",0dh,0ah,'$'
prompt4 db 0dh,0ah,"Sum: $"


;TASK:
;1. Why are we using two instructions to load offeset to data segment into DS?  Can we use "mov ds,@data" instead?
;2. Try the program with different combination of first and second number.  What is the limitation?
;3. EDIT THE PROGRAM TO CATER FOR WIDER RANGE OF INPUT AND RESULT: the program cannot display SUM exceeding 9
;4. EDIT THE PROGRAM TO LOOP AND REPEAT UNTIL ESC KEY PRESSED

end

