title   Program to read 2 char and print them on screen using buffered input
.model  small
.stack  100

.code
main:   mov     ax,@data
        mov     ds,ax           ; set data segment

        mov     buff,3          ; set maximum input to 3 chars (incl CR)

        mov     ah,0ah          ; buffered input to store at
        mov     dx,offset buff  ; buff
        int     21h

        mov     dl,0dh          ; enter new line
        mov     ah,2
        int     21h

        mov     dl,0ah
        mov     ah,2
        int     21h

first:  mov     dl,buff+2       ; transfer input ASCII to DL for
        mov     ah,2            ; send the ASCII to print on screen
        int     21h

second: mov     dl,buff+3       ; transfer input ASCII to DL for
        mov     ah,2            ; send the ASCII to print on screen
        int     21h

        mov     ax,4c00h        ; return to OS
        int     21h

.data
buff    db      3

end

; Improvements:
; - add in prompt messages (print string) to improve user friendliness.
; - check input range for valid printable char

